diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/olsr/model/olsr-routing-protocol.cc ns-3.40/src/olsr/model/olsr-routing-protocol.cc
--- ns-3.39/src/olsr/model/olsr-routing-protocol.cc	2023-07-05 14:23:48.069428200 -0700
+++ ns-3.40/src/olsr/model/olsr-routing-protocol.cc	2023-09-27 13:30:37.862839700 -0700
@@ -306,9 +306,7 @@
         m_recvSocket = nullptr;
     }
 
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::iterator iter = m_sendSockets.begin();
-         iter != m_sendSockets.end();
-         iter++)
+    for (auto iter = m_sendSockets.begin(); iter != m_sendSockets.end(); iter++)
     {
         iter->first->Close();
     }
@@ -337,12 +335,14 @@
     *os << std::setw(16) << "Interface";
     *os << "Distance" << std::endl;
 
-    for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator iter = m_table.begin();
-         iter != m_table.end();
-         iter++)
+    for (auto iter = m_table.begin(); iter != m_table.end(); iter++)
     {
-        *os << std::setw(16) << iter->first;
-        *os << std::setw(16) << iter->second.nextAddr;
+        std::ostringstream dest;
+        std::ostringstream nextHop;
+        dest << iter->first;
+        nextHop << iter->second.nextAddr;
+        *os << std::setw(16) << dest.str();
+        *os << std::setw(16) << nextHop.str();
         *os << std::setw(16);
         if (!Names::FindName(m_ipv4->GetNetDevice(iter->second.interface)).empty())
         {
@@ -364,7 +364,7 @@
     }
     else
     {
-        *os << "HNA Routing Table: empty" << std::endl;
+        *os << "HNA Routing Table: empty" << std::endl << std::endl;
     }
     // Restore the previous ostream state
     (*os).copyfmt(oldState);
@@ -546,8 +546,7 @@
 
     m_rxPacketTrace(olsrPacketHeader, messages);
 
-    for (MessageList::const_iterator messageIter = messages.begin(); messageIter != messages.end();
-         messageIter++)
+    for (auto messageIter = messages.begin(); messageIter != messages.end(); messageIter++)
     {
         const MessageHeader& messageHeader = *messageIter;
         // If ttl is less than or equal to zero, or
@@ -620,9 +619,7 @@
 
             // If the message has been considered for forwarding, it should
             // not be retransmitted again
-            for (std::vector<Ipv4Address>::const_iterator it = duplicated->ifaceList.begin();
-                 it != duplicated->ifaceList.end();
-                 it++)
+            for (auto it = duplicated->ifaceList.begin(); it != duplicated->ifaceList.end(); it++)
             {
                 if (*it == receiverIfaceAddr)
                 {
@@ -662,8 +659,7 @@
 RoutingProtocol::Degree(const NeighborTuple& tuple)
 {
     int degree = 0;
-    for (TwoHopNeighborSet::const_iterator it = m_state.GetTwoHopNeighbors().begin();
-         it != m_state.GetTwoHopNeighbors().end();
+    for (auto it = m_state.GetTwoHopNeighbors().begin(); it != m_state.GetTwoHopNeighbors().end();
          it++)
     {
         const TwoHopNeighborTuple& nb2hop_tuple = *it;
@@ -694,8 +690,7 @@
 {
     // first gather all 2-hop neighbors to be removed
     std::set<Ipv4Address> toRemove;
-    for (TwoHopNeighborSet::iterator twoHopNeigh = N2.begin(); twoHopNeigh != N2.end();
-         twoHopNeigh++)
+    for (auto twoHopNeigh = N2.begin(); twoHopNeigh != N2.end(); twoHopNeigh++)
     {
         if (twoHopNeigh->neighborMainAddr == neighborMainAddr)
         {
@@ -703,7 +698,7 @@
         }
     }
     // Now remove all matching records from N2
-    for (TwoHopNeighborSet::iterator twoHopNeigh = N2.begin(); twoHopNeigh != N2.end();)
+    for (auto twoHopNeigh = N2.begin(); twoHopNeigh != N2.end();)
     {
         if (toRemove.find(twoHopNeigh->twoHopNeighborAddr) != toRemove.end())
         {
@@ -729,8 +724,7 @@
     // N is the subset of neighbors of the node, which are
     // neighbor "of the interface I"
     NeighborSet N;
-    for (NeighborSet::const_iterator neighbor = m_state.GetNeighbors().begin();
-         neighbor != m_state.GetNeighbors().end();
+    for (auto neighbor = m_state.GetNeighbors().begin(); neighbor != m_state.GetNeighbors().end();
          neighbor++)
     {
         if (neighbor->status == NeighborTuple::STATUS_SYM) // I think that we need this check
@@ -746,7 +740,7 @@
     // (iii) all the symmetric neighbors: the nodes for which there exists a symmetric
     //       link to this node on some interface.
     TwoHopNeighborSet N2;
-    for (TwoHopNeighborSet::const_iterator twoHopNeigh = m_state.GetTwoHopNeighbors().begin();
+    for (auto twoHopNeigh = m_state.GetTwoHopNeighbors().begin();
          twoHopNeigh != m_state.GetTwoHopNeighbors().end();
          twoHopNeigh++)
     {
@@ -760,7 +754,7 @@
         //  excluding:
         // (i)   the nodes only reachable by members of N with willingness Willingness::NEVER
         bool ok = false;
-        for (NeighborSet::const_iterator neigh = N.begin(); neigh != N.end(); neigh++)
+        for (auto neigh = N.begin(); neigh != N.end(); neigh++)
         {
             if (neigh->neighborMainAddr == twoHopNeigh->neighborMainAddr)
             {
@@ -776,7 +770,7 @@
         // excluding:
         // (iii) all the symmetric neighbors: the nodes for which there exists a symmetric
         //       link to this node on some interface.
-        for (NeighborSet::const_iterator neigh = N.begin(); neigh != N.end(); neigh++)
+        for (auto neigh = N.begin(); neigh != N.end(); neigh++)
         {
             if (neigh->neighborMainAddr == twoHopNeigh->twoHopNeighborAddr)
             {
@@ -795,9 +789,9 @@
     {
         std::ostringstream os;
         os << "[";
-        for (TwoHopNeighborSet::const_iterator iter = N2.begin(); iter != N2.end(); iter++)
+        for (auto iter = N2.begin(); iter != N2.end(); iter++)
         {
-            TwoHopNeighborSet::const_iterator next = iter;
+            auto next = iter;
             next++;
             os << iter->neighborMainAddr << "->" << iter->twoHopNeighborAddr;
             if (next != N2.end())
@@ -812,7 +806,7 @@
 
     // 1. Start with an MPR set made of all members of N with
     // N_willingness equal to Willingness::ALWAYS
-    for (NeighborSet::const_iterator neighbor = N.begin(); neighbor != N.end(); neighbor++)
+    for (auto neighbor = N.begin(); neighbor != N.end(); neighbor++)
     {
         if (neighbor->willingness == Willingness::ALWAYS)
         {
@@ -829,14 +823,11 @@
     // 3. Add to the MPR set those nodes in N, which are the *only*
     // nodes to provide reachability to a node in N2.
     std::set<Ipv4Address> coveredTwoHopNeighbors;
-    for (TwoHopNeighborSet::const_iterator twoHopNeigh = N2.begin(); twoHopNeigh != N2.end();
-         twoHopNeigh++)
+    for (auto twoHopNeigh = N2.begin(); twoHopNeigh != N2.end(); twoHopNeigh++)
     {
         bool onlyOne = true;
         // try to find another neighbor that can reach twoHopNeigh->twoHopNeighborAddr
-        for (TwoHopNeighborSet::const_iterator otherTwoHopNeigh = N2.begin();
-             otherTwoHopNeigh != N2.end();
-             otherTwoHopNeigh++)
+        for (auto otherTwoHopNeigh = N2.begin(); otherTwoHopNeigh != N2.end(); otherTwoHopNeigh++)
         {
             if (otherTwoHopNeigh->twoHopNeighborAddr == twoHopNeigh->twoHopNeighborAddr &&
                 otherTwoHopNeigh->neighborMainAddr != twoHopNeigh->neighborMainAddr)
@@ -854,8 +845,7 @@
             mprSet.insert(twoHopNeigh->neighborMainAddr);
 
             // take note of all the 2-hop neighbors reachable by the newly elected MPR
-            for (TwoHopNeighborSet::const_iterator otherTwoHopNeigh = N2.begin();
-                 otherTwoHopNeigh != N2.end();
+            for (auto otherTwoHopNeigh = N2.begin(); otherTwoHopNeigh != N2.end();
                  otherTwoHopNeigh++)
             {
                 if (otherTwoHopNeigh->neighborMainAddr == twoHopNeigh->neighborMainAddr)
@@ -866,7 +856,7 @@
         }
     }
     // Remove the nodes from N2 which are now covered by a node in the MPR set.
-    for (TwoHopNeighborSet::iterator twoHopNeigh = N2.begin(); twoHopNeigh != N2.end();)
+    for (auto twoHopNeigh = N2.begin(); twoHopNeigh != N2.end();)
     {
         if (coveredTwoHopNeighbors.find(twoHopNeigh->twoHopNeighborAddr) !=
             coveredTwoHopNeighbors.end())
@@ -892,9 +882,9 @@
         {
             std::ostringstream os;
             os << "[";
-            for (TwoHopNeighborSet::const_iterator iter = N2.begin(); iter != N2.end(); iter++)
+            for (auto iter = N2.begin(); iter != N2.end(); iter++)
             {
-                TwoHopNeighborSet::const_iterator next = iter;
+                auto next = iter;
                 next++;
                 os << iter->neighborMainAddr << "->" << iter->twoHopNeighborAddr;
                 if (next != N2.end())
@@ -913,11 +903,11 @@
         // through this 1-hop neighbor
         std::map<int, std::vector<const NeighborTuple*>> reachability;
         std::set<int> rs;
-        for (NeighborSet::iterator it = N.begin(); it != N.end(); it++)
+        for (auto it = N.begin(); it != N.end(); it++)
         {
             const NeighborTuple& nb_tuple = *it;
             int r = 0;
-            for (TwoHopNeighborSet::iterator it2 = N2.begin(); it2 != N2.end(); it2++)
+            for (auto it2 = N2.begin(); it2 != N2.end(); it2++)
             {
                 const TwoHopNeighborTuple& nb2hop_tuple = *it2;
                 if (nb_tuple.neighborMainAddr == nb2hop_tuple.neighborMainAddr)
@@ -939,16 +929,14 @@
         // by a node in the MPR set.
         const NeighborTuple* max = nullptr;
         int max_r = 0;
-        for (std::set<int>::iterator it = rs.begin(); it != rs.end(); it++)
+        for (auto it = rs.begin(); it != rs.end(); it++)
         {
             int r = *it;
             if (r == 0)
             {
                 continue;
             }
-            for (std::vector<const NeighborTuple*>::iterator it2 = reachability[r].begin();
-                 it2 != reachability[r].end();
-                 it2++)
+            for (auto it2 = reachability[r].begin(); it2 != reachability[r].end(); it2++)
             {
                 const NeighborTuple* nb_tuple = *it2;
                 if (max == nullptr || nb_tuple->willingness > max->willingness)
@@ -987,9 +975,9 @@
     {
         std::ostringstream os;
         os << "[";
-        for (MprSet::const_iterator iter = mprSet.begin(); iter != mprSet.end(); iter++)
+        for (auto iter = mprSet.begin(); iter != mprSet.end(); iter++)
         {
-            MprSet::const_iterator next = iter;
+            auto next = iter;
             next++;
             os << *iter;
             if (next != mprSet.end())
@@ -1032,7 +1020,7 @@
     // 2. The new routing entries are added starting with the
     // symmetric neighbors (h=1) as the destination nodes.
     const NeighborSet& neighborSet = m_state.GetNeighbors();
-    for (NeighborSet::const_iterator it = neighborSet.begin(); it != neighborSet.end(); it++)
+    for (auto it = neighborSet.begin(); it != neighborSet.end(); it++)
     {
         const NeighborTuple& nb_tuple = *it;
         NS_LOG_DEBUG("Looking at neighbor tuple: " << nb_tuple);
@@ -1041,7 +1029,7 @@
             bool nb_main_addr = false;
             const LinkTuple* lt = nullptr;
             const LinkSet& linkSet = m_state.GetLinks();
-            for (LinkSet::const_iterator it2 = linkSet.begin(); it2 != linkSet.end(); it2++)
+            for (auto it2 = linkSet.begin(); it2 != linkSet.end(); it2++)
             {
                 const LinkTuple& link_tuple = *it2;
                 NS_LOG_DEBUG("Looking at link tuple: "
@@ -1097,9 +1085,7 @@
     //  N_neighbor_main_addr correspond to a neighbor node with
     //  willingness different of Willingness::NEVER,
     const TwoHopNeighborSet& twoHopNeighbors = m_state.GetTwoHopNeighbors();
-    for (TwoHopNeighborSet::const_iterator it = twoHopNeighbors.begin();
-         it != twoHopNeighbors.end();
-         it++)
+    for (auto it = twoHopNeighbors.begin(); it != twoHopNeighbors.end(); it++)
     {
         const TwoHopNeighborTuple& nb2hop_tuple = *it;
 
@@ -1122,9 +1108,7 @@
         // neighbor set where N_neighbor_main_addr correspond to a
         // neighbor node with willingness different of Willingness::NEVER...
         bool nb2hopOk = false;
-        for (NeighborSet::const_iterator neighbor = neighborSet.begin();
-             neighbor != neighborSet.end();
-             neighbor++)
+        for (auto neighbor = neighborSet.begin(); neighbor != neighborSet.end(); neighbor++)
         {
             if (neighbor->neighborMainAddr == nb2hop_tuple.neighborMainAddr &&
                 neighbor->willingness != Willingness::NEVER)
@@ -1178,7 +1162,7 @@
         // is equal to h, then a new route entry MUST be recorded in
         // the routing table (if it does not already exist)
         const TopologySet& topology = m_state.GetTopologySet();
-        for (TopologySet::const_iterator it = topology.begin(); it != topology.end(); it++)
+        for (auto it = topology.begin(); it != topology.end(); it++)
         {
             const TopologyTuple& topology_tuple = *it;
             NS_LOG_LOGIC("Looking at topology tuple: " << topology_tuple);
@@ -1228,7 +1212,7 @@
     // AND there is no routing entry such that:
     // R_dest_addr == I_iface_addr
     const IfaceAssocSet& ifaceAssocSet = m_state.GetIfaceAssocSet();
-    for (IfaceAssocSet::const_iterator it = ifaceAssocSet.begin(); it != ifaceAssocSet.end(); it++)
+    for (auto it = ifaceAssocSet.begin(); it != ifaceAssocSet.end(); it++)
     {
         const IfaceAssocTuple& tuple = *it;
         RoutingTableEntry entry1;
@@ -1260,8 +1244,7 @@
         m_hnaRoutingTable->RemoveRoute(0);
     }
 
-    for (AssociationSet::const_iterator it = associationSet.begin(); it != associationSet.end();
-         it++)
+    for (auto it = associationSet.begin(); it != associationSet.end(); it++)
     {
         const AssociationTuple& tuple = *it;
 
@@ -1271,7 +1254,7 @@
         bool goToNextAssociationTuple = false;
         const Associations& localHnaAssociations = m_state.GetAssociations();
         NS_LOG_DEBUG("Nb local associations: " << localHnaAssociations.size());
-        for (Associations::const_iterator assocIterator = localHnaAssociations.begin();
+        for (auto assocIterator = localHnaAssociations.begin();
              assocIterator != localHnaAssociations.end();
              assocIterator++)
         {
@@ -1348,7 +1331,7 @@
         const LinkSet& links = m_state.GetLinks();
         NS_LOG_DEBUG(Simulator::Now().As(Time::S)
                      << " ** BEGIN dump Link Set for OLSR Node " << m_mainAddress);
-        for (LinkSet::const_iterator link = links.begin(); link != links.end(); link++)
+        for (auto link = links.begin(); link != links.end(); link++)
         {
             NS_LOG_DEBUG(*link);
         }
@@ -1357,8 +1340,7 @@
         const NeighborSet& neighbors = m_state.GetNeighbors();
         NS_LOG_DEBUG(Simulator::Now().As(Time::S)
                      << " ** BEGIN dump Neighbor Set for OLSR Node " << m_mainAddress);
-        for (NeighborSet::const_iterator neighbor = neighbors.begin(); neighbor != neighbors.end();
-             neighbor++)
+        for (auto neighbor = neighbors.begin(); neighbor != neighbors.end(); neighbor++)
         {
             NS_LOG_DEBUG(*neighbor);
         }
@@ -1374,9 +1356,7 @@
         const TwoHopNeighborSet& twoHopNeighbors = m_state.GetTwoHopNeighbors();
         NS_LOG_DEBUG(Simulator::Now().As(Time::S)
                      << " ** BEGIN dump TwoHopNeighbor Set for OLSR Node " << m_mainAddress);
-        for (TwoHopNeighborSet::const_iterator tuple = twoHopNeighbors.begin();
-             tuple != twoHopNeighbors.end();
-             tuple++)
+        for (auto tuple = twoHopNeighbors.begin(); tuple != twoHopNeighbors.end(); tuple++)
         {
             NS_LOG_DEBUG(*tuple);
         }
@@ -1422,9 +1402,7 @@
 
     // 4. For each of the advertised neighbor main address received in
     // the TC message:
-    for (std::vector<Ipv4Address>::const_iterator i = tc.neighborAddresses.begin();
-         i != tc.neighborAddresses.end();
-         i++)
+    for (auto i = tc.neighborAddresses.begin(); i != tc.neighborAddresses.end(); i++)
     {
         const Ipv4Address& addr = *i;
         // 4.1. If there exist some tuple in the topology set where:
@@ -1467,7 +1445,7 @@
         const TopologySet& topology = m_state.GetTopologySet();
         NS_LOG_DEBUG(Simulator::Now().As(Time::S)
                      << " ** BEGIN dump TopologySet for OLSR Node " << m_mainAddress);
-        for (TopologySet::const_iterator tuple = topology.begin(); tuple != topology.end(); tuple++)
+        for (auto tuple = topology.begin(); tuple != topology.end(); tuple++)
         {
             NS_LOG_DEBUG(*tuple);
         }
@@ -1496,13 +1474,11 @@
     }
 
     // 2. For each interface address listed in the MID message
-    for (std::vector<Ipv4Address>::const_iterator i = mid.interfaceAddresses.begin();
-         i != mid.interfaceAddresses.end();
-         i++)
+    for (auto i = mid.interfaceAddresses.begin(); i != mid.interfaceAddresses.end(); i++)
     {
         bool updated = false;
         IfaceAssocSet& ifaceAssoc = m_state.GetIfaceAssocSetMutable();
-        for (IfaceAssocSet::iterator tuple = ifaceAssoc.begin(); tuple != ifaceAssoc.end(); tuple++)
+        for (auto tuple = ifaceAssoc.begin(); tuple != ifaceAssoc.end(); tuple++)
         {
             if (tuple->ifaceAddr == *i && tuple->mainAddr == msg.GetOriginatorAddress())
             {
@@ -1531,15 +1507,13 @@
     // TwoHopNeighborTuples, update the neighbor addresses taking into account
     // the new MID information.
     NeighborSet& neighbors = m_state.GetNeighbors();
-    for (NeighborSet::iterator neighbor = neighbors.begin(); neighbor != neighbors.end();
-         neighbor++)
+    for (auto neighbor = neighbors.begin(); neighbor != neighbors.end(); neighbor++)
     {
         neighbor->neighborMainAddr = GetMainAddress(neighbor->neighborMainAddr);
     }
 
     TwoHopNeighborSet& twoHopNeighbors = m_state.GetTwoHopNeighbors();
-    for (TwoHopNeighborSet::iterator twoHopNeighbor = twoHopNeighbors.begin();
-         twoHopNeighbor != twoHopNeighbors.end();
+    for (auto twoHopNeighbor = twoHopNeighbors.begin(); twoHopNeighbor != twoHopNeighbors.end();
          twoHopNeighbor++)
     {
         twoHopNeighbor->neighborMainAddr = GetMainAddress(twoHopNeighbor->neighborMainAddr);
@@ -1565,10 +1539,7 @@
     // 2. Otherwise, for each (network address, netmask) pair in the
     // message:
 
-    for (std::vector<olsr::MessageHeader::Hna::Association>::const_iterator it =
-             hna.associations.begin();
-         it != hna.associations.end();
-         it++)
+    for (auto it = hna.associations.begin(); it != hna.associations.end(); it++)
     {
         AssociationTuple* tuple =
             m_state.FindAssociationTuple(msg.GetOriginatorAddress(), it->address, it->mask);
@@ -1707,9 +1678,7 @@
     m_txPacketTrace(header, containedMessages);
 
     // Send it
-    for (std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator i = m_sendSockets.begin();
-         i != m_sendSockets.end();
-         i++)
+    for (auto i = m_sendSockets.begin(); i != m_sendSockets.end(); i++)
     {
         Ptr<Packet> pkt = packet->Copy();
         Ipv4Address bcast = i->second.GetLocal().GetSubnetDirectedBroadcast(i->second.GetMask());
@@ -1727,9 +1696,7 @@
 
     MessageList msglist;
 
-    for (std::vector<olsr::MessageHeader>::const_iterator message = m_queuedMessages.begin();
-         message != m_queuedMessages.end();
-         message++)
+    for (auto message = m_queuedMessages.begin(); message != m_queuedMessages.end(); message++)
     {
         Ptr<Packet> p = Create<Packet>();
         p->AddHeader(*message);
@@ -1774,8 +1741,7 @@
     std::vector<olsr::MessageHeader::Hello::LinkMessage>& linkMessages = hello.linkMessages;
 
     const LinkSet& links = m_state.GetLinks();
-    for (LinkSet::const_iterator link_tuple = links.begin(); link_tuple != links.end();
-         link_tuple++)
+    for (auto link_tuple = links.begin(); link_tuple != links.end(); link_tuple++)
     {
         if (!(GetMainAddress(link_tuple->localIfaceAddr) == m_mainAddress &&
               link_tuple->time >= now))
@@ -1809,7 +1775,7 @@
         else
         {
             bool ok = false;
-            for (NeighborSet::const_iterator nb_tuple = m_state.GetNeighbors().begin();
+            for (auto nb_tuple = m_state.GetNeighbors().begin();
                  nb_tuple != m_state.GetNeighbors().end();
                  nb_tuple++)
             {
@@ -1880,7 +1846,7 @@
     olsr::MessageHeader::Tc& tc = msg.GetTc();
     tc.ansn = m_ansn;
 
-    for (MprSelectorSet::const_iterator mprsel_tuple = m_state.GetMprSelectors().begin();
+    for (auto mprsel_tuple = m_state.GetMprSelectors().begin();
          mprsel_tuple != m_state.GetMprSelectors().end();
          mprsel_tuple++)
     {
@@ -1951,9 +1917,7 @@
 
     // Add all local HNA associations to the HNA message
     const Associations& localHnaAssociations = m_state.GetAssociations();
-    for (Associations::const_iterator it = localHnaAssociations.begin();
-         it != localHnaAssociations.end();
-         it++)
+    for (auto it = localHnaAssociations.begin(); it != localHnaAssociations.end(); it++)
     {
         olsr::MessageHeader::Hna::Association assoc = {it->networkAddr, it->netmask};
         associations.push_back(assoc);
@@ -1974,7 +1938,7 @@
     // Check if the (networkAddr, netmask) tuple already exist
     // in the list of local HNA associations
     const Associations& localHnaAssociations = m_state.GetAssociations();
-    for (Associations::const_iterator assocIterator = localHnaAssociations.begin();
+    for (auto assocIterator = localHnaAssociations.begin();
          assocIterator != localHnaAssociations.end();
          assocIterator++)
     {
@@ -2048,7 +2012,7 @@
 bool
 RoutingProtocol::UsesNonOlsrOutgoingInterface(const Ipv4RoutingTableEntry& route)
 {
-    std::set<uint32_t>::const_iterator ci = m_interfaceExclusions.find(route.GetInterface());
+    auto ci = m_interfaceExclusions.find(route.GetInterface());
     // The outgoing interface is a non-OLSR interface if a match is found
     // before reaching the end of the list of excluded interfaces
     return ci != m_interfaceExclusions.end();
@@ -2088,13 +2052,11 @@
     }
 
     link_tuple->asymTime = now + msg.GetVTime();
-    for (std::vector<olsr::MessageHeader::Hello::LinkMessage>::const_iterator linkMessage =
-             hello.linkMessages.begin();
-         linkMessage != hello.linkMessages.end();
+    for (auto linkMessage = hello.linkMessages.begin(); linkMessage != hello.linkMessages.end();
          linkMessage++)
     {
-        LinkType linkType = LinkType(linkMessage->linkCode & 0x03);
-        NeighborType neighborType = NeighborType((linkMessage->linkCode >> 2) & 0x03);
+        auto linkType = LinkType(linkMessage->linkCode & 0x03);
+        auto neighborType = NeighborType((linkMessage->linkCode >> 2) & 0x03);
 
         NS_LOG_DEBUG("Looking at HELLO link messages with Link Type "
                      << linkType << " and Neighbor Type " << neighborType);
@@ -2108,8 +2070,7 @@
             continue;
         }
 
-        for (std::vector<Ipv4Address>::const_iterator neighIfaceAddr =
-                 linkMessage->neighborInterfaceAddresses.begin();
+        for (auto neighIfaceAddr = linkMessage->neighborInterfaceAddresses.begin();
              neighIfaceAddr != linkMessage->neighborInterfaceAddresses.end();
              neighIfaceAddr++)
         {
@@ -2184,8 +2145,7 @@
 
     NS_LOG_DEBUG("Olsr node " << m_mainAddress << ": PopulateTwoHopNeighborSet BEGIN");
 
-    for (LinkSet::const_iterator link_tuple = m_state.GetLinks().begin();
-         link_tuple != m_state.GetLinks().end();
+    for (auto link_tuple = m_state.GetLinks().begin(); link_tuple != m_state.GetLinks().end();
          link_tuple++)
     {
         NS_LOG_LOGIC("Looking at link tuple: " << *link_tuple);
@@ -2207,17 +2167,14 @@
             continue;
         }
 
-        typedef std::vector<olsr::MessageHeader::Hello::LinkMessage> LinkMessageVec;
-        for (LinkMessageVec::const_iterator linkMessage = hello.linkMessages.begin();
-             linkMessage != hello.linkMessages.end();
+        for (auto linkMessage = hello.linkMessages.begin(); linkMessage != hello.linkMessages.end();
              linkMessage++)
         {
-            NeighborType neighborType = NeighborType((linkMessage->linkCode >> 2) & 0x3);
+            auto neighborType = NeighborType((linkMessage->linkCode >> 2) & 0x3);
             NS_LOG_DEBUG(
                 "Looking at Link Message from HELLO message: neighborType=" << neighborType);
 
-            for (std::vector<Ipv4Address>::const_iterator nb2hop_addr_iter =
-                     linkMessage->neighborInterfaceAddresses.begin();
+            for (auto nb2hop_addr_iter = linkMessage->neighborInterfaceAddresses.begin();
                  nb2hop_addr_iter != linkMessage->neighborInterfaceAddresses.end();
                  nb2hop_addr_iter++)
             {
@@ -2292,18 +2249,15 @@
 
     Time now = Simulator::Now();
 
-    typedef std::vector<olsr::MessageHeader::Hello::LinkMessage> LinkMessageVec;
-    for (LinkMessageVec::const_iterator linkMessage = hello.linkMessages.begin();
-         linkMessage != hello.linkMessages.end();
+    for (auto linkMessage = hello.linkMessages.begin(); linkMessage != hello.linkMessages.end();
          linkMessage++)
     {
-        NeighborType neighborType = NeighborType(linkMessage->linkCode >> 2);
+        auto neighborType = NeighborType(linkMessage->linkCode >> 2);
         if (neighborType == NeighborType::MPR_NEIGH)
         {
             NS_LOG_DEBUG("Processing a link message with neighbor type MPR_NEIGH");
 
-            for (std::vector<Ipv4Address>::const_iterator nb_iface_addr =
-                     linkMessage->neighborInterfaceAddresses.begin();
+            for (auto nb_iface_addr = linkMessage->neighborInterfaceAddresses.begin();
                  nb_iface_addr != linkMessage->neighborInterfaceAddresses.end();
                  nb_iface_addr++)
             {
@@ -2466,7 +2420,7 @@
         bool hasSymmetricLink = false;
 
         const LinkSet& linkSet = m_state.GetLinks();
-        for (LinkSet::const_iterator it = linkSet.begin(); it != linkSet.end(); it++)
+        for (auto it = linkSet.begin(); it != linkSet.end(); it++)
         {
             const LinkTuple& link_tuple = *it;
             if (GetMainAddress(link_tuple.neighborIfaceAddr) == nb_tuple->neighborMainAddr &&
@@ -2886,7 +2840,7 @@
 RoutingProtocol::Lookup(const Ipv4Address& dest, RoutingTableEntry& outEntry) const
 {
     // Get the iterator at "dest" position
-    std::map<Ipv4Address, RoutingTableEntry>::const_iterator it = m_table.find(dest);
+    auto it = m_table.find(dest);
     // If there is no route to "dest", return NULL
     if (it == m_table.end())
     {
@@ -2923,7 +2877,7 @@
     RoutingTableEntry entry2;
     bool found = false;
 
-    if (Lookup(header.GetDestination(), entry1) != 0)
+    if (Lookup(header.GetDestination(), entry1))
     {
         bool foundSendEntry = FindSendEntry(entry1, entry2);
         if (!foundSendEntry)
@@ -3098,9 +3052,7 @@
                                       << ": RouteInput for dest=" << header.GetDestination()
                                       << " --> NOT FOUND; ** Dumping routing table...");
 
-            for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator iter = m_table.begin();
-                 iter != m_table.end();
-                 iter++)
+            for (auto iter = m_table.begin(); iter != m_table.end(); iter++)
             {
                 NS_LOG_DEBUG("dest=" << iter->first << " --> next=" << iter->second.nextAddr
                                      << " via interface " << iter->second.interface);
@@ -3184,9 +3136,7 @@
 RoutingProtocol::GetRoutingTableEntries() const
 {
     std::vector<RoutingTableEntry> retval;
-    for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator iter = m_table.begin();
-         iter != m_table.end();
-         iter++)
+    for (auto iter = m_table.begin(); iter != m_table.end(); iter++)
     {
         retval.push_back(iter->second);
     }
@@ -3240,8 +3190,7 @@
 bool
 RoutingProtocol::IsMyOwnAddress(const Ipv4Address& a) const
 {
-    std::map<Ptr<Socket>, Ipv4InterfaceAddress>::const_iterator j;
-    for (j = m_sendSockets.begin(); j != m_sendSockets.end(); ++j)
+    for (auto j = m_sendSockets.begin(); j != m_sendSockets.end(); ++j)
     {
         Ipv4InterfaceAddress iface = j->second;
         if (a == iface.GetLocal())
@@ -3259,14 +3208,12 @@
     Time now = Simulator::Now();
     NS_LOG_DEBUG("Dumping for node with main address " << m_mainAddress);
     NS_LOG_DEBUG(" Neighbor set");
-    for (NeighborSet::const_iterator iter = m_state.GetNeighbors().begin();
-         iter != m_state.GetNeighbors().end();
-         iter++)
+    for (auto iter = m_state.GetNeighbors().begin(); iter != m_state.GetNeighbors().end(); iter++)
     {
         NS_LOG_DEBUG("  " << *iter);
     }
     NS_LOG_DEBUG(" Two-hop neighbor set");
-    for (TwoHopNeighborSet::const_iterator iter = m_state.GetTwoHopNeighbors().begin();
+    for (auto iter = m_state.GetTwoHopNeighbors().begin();
          iter != m_state.GetTwoHopNeighbors().end();
          iter++)
     {
@@ -3276,9 +3223,7 @@
         }
     }
     NS_LOG_DEBUG(" Routing table");
-    for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator iter = m_table.begin();
-         iter != m_table.end();
-         iter++)
+    for (auto iter = m_table.begin(); iter != m_table.end(); iter++)
     {
         NS_LOG_DEBUG("  dest=" << iter->first << " --> next=" << iter->second.nextAddr
                                << " via interface " << iter->second.interface);
